package com.sv.service.oms;
import com.github.pagehelper.PageHelper;
import com.ydd.framework.core.common.Pagination;
import com.ydd.framework.core.entity.enums.StatusEnum;
import com.ydd.framework.core.service.impl.BaseServiceImpl;

import com.sv.entity.VipCard;
import com.sv.mapper.VipCardMapper;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

/**
 * Service - 会员卡
 *
 * @author yechanglin
 * @since 2018-08-11
 */
@Service("VipCardServiceOms")
@Transactional(readOnly = true)
public class VipCardService extends BaseServiceImpl {

	private final Logger logger = LoggerFactory.getLogger(VipCardService.class);

	@Resource
	private VipCardMapper vipCardMapper;

	/**
	 * 创建会员卡
	 *
	 * @param vipCard 会员卡
	 */

	@Transactional
    public void save(VipCard vipCard) {
		if (vipCard.getId() != null && vipCard.getId() > 0) {
			// 更新
			vipCardMapper.update(vipCard);
		} else {
			// 新建
			vipCardMapper.insert(vipCard);
		}
	}

	/**
	 * 更新会员卡
 	 *
	 * @param vipCard 会员卡
	 */

	@Transactional
    public void update(VipCard vipCard) {
		vipCardMapper.update(vipCard);
	}

	/**
	 * 删除会员卡
	 *
	 * @param id 编号
   	 * @return 删除数量
	 */

	@Transactional
    public Integer delete(Integer id) {
		if (id == null || id <= 0) {
			return 0;
		}
		return vipCardMapper.delete(id);
	}

	/**
	 * 删除会员卡
	 *
	 * @param ids 编号数组
	 * @return 删除数量
	 */

	@Transactional
    public Integer deleteByIds(Integer[] ids) {
		if (ids == null || ids.length == 0) {
			return 0;
		}
		return vipCardMapper.deleteByIds(ids);
	}

	/**
	 * 查询会员卡
	 *
	 * @param id 编号
	 * @return 会员卡
	 */
	public VipCard findById(Integer id) {
		return vipCardMapper.findById(id);
	}

	/**
	 * 查询会员卡
	 *
	 * @param pagination 分页信息
	 * @return 分页结果
	 */

	public Pagination findPage(Pagination pagination) {
		PageHelper.startPage(pagination.getPage(), pagination.getPageSize());
		PageHelper.orderBy("id desc");
		pagination.setQueryResult(vipCardMapper.findAll());
		return pagination;
	}

	/**
	 * 更新状态
	 *
	 * @param ids 编号
	 * @param status 状态
	 * @return 更新数量
	 */

	@Transactional
	public Integer updateStatus(Integer[] ids, Byte status) {
		if (ids == null) {
			return 0;
		}
		if (status == null) {
			status = StatusEnum.DISABLE.value;
		}

		return vipCardMapper.updateStatus(ids, status);
	}

}

